KeySetLink create_augroup_table[] = {
  {"clear", offsetof(KeyDict_create_augroup, clear)},
  {NULL, 0},
};

int create_augroup_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 5: low = 0;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, create_augroup_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_create_augroup_get_field(void *retval, const char *str, size_t len)
{
  int hash = create_augroup_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + create_augroup_table[hash].ptr_off);
}

KeySetLink get_commands_table[] = {
  {"builtin", offsetof(KeyDict_get_commands, builtin)},
  {NULL, 0},
};

int get_commands_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 7: low = 0;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, get_commands_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_get_commands_get_field(void *retval, const char *str, size_t len)
{
  int hash = get_commands_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + get_commands_table[hash].ptr_off);
}

KeySetLink create_autocmd_table[] = {
  {"desc", offsetof(KeyDict_create_autocmd, desc)},
  {"once", offsetof(KeyDict_create_autocmd, once)},
  {"group", offsetof(KeyDict_create_autocmd, group)},
  {"buffer", offsetof(KeyDict_create_autocmd, buffer)},
  {"nested", offsetof(KeyDict_create_autocmd, nested)},
  {"command", offsetof(KeyDict_create_autocmd, command)},
  {"pattern", offsetof(KeyDict_create_autocmd, pattern)},
  {"callback", offsetof(KeyDict_create_autocmd, callback)},
  {NULL, 0},
};

int create_autocmd_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 4: switch (str[0]) {
      case 'd': low = 0; break;
      case 'o': low = 1; break;
      default: break;
    }
    break;
    case 5: low = 2;   break;
    case 6: switch (str[0]) {
      case 'b': low = 3; break;
      case 'n': low = 4; break;
      default: break;
    }
    break;
    case 7: switch (str[0]) {
      case 'c': low = 5; break;
      case 'p': low = 6; break;
      default: break;
    }
    break;
    case 8: low = 7;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, create_autocmd_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_create_autocmd_get_field(void *retval, const char *str, size_t len)
{
  int hash = create_autocmd_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + create_autocmd_table[hash].ptr_off);
}

KeySetLink user_command_table[] = {
  {"bar", offsetof(KeyDict_user_command, bar)},
  {"addr", offsetof(KeyDict_user_command, addr)},
  {"bang", offsetof(KeyDict_user_command, bang)},
  {"desc", offsetof(KeyDict_user_command, desc)},
  {"count", offsetof(KeyDict_user_command, count)},
  {"force", offsetof(KeyDict_user_command, force)},
  {"nargs", offsetof(KeyDict_user_command, nargs)},
  {"range", offsetof(KeyDict_user_command, range)},
  {"complete", offsetof(KeyDict_user_command, complete)},
  {"register", offsetof(KeyDict_user_command, register_)},
  {"keepscript", offsetof(KeyDict_user_command, keepscript)},
  {NULL, 0},
};

int user_command_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 3: low = 0;   break;
    case 4: switch (str[0]) {
      case 'a': low = 1; break;
      case 'b': low = 2; break;
      case 'd': low = 3; break;
      default: break;
    }
    break;
    case 5: switch (str[0]) {
      case 'c': low = 4; break;
      case 'f': low = 5; break;
      case 'n': low = 6; break;
      case 'r': low = 7; break;
      default: break;
    }
    break;
    case 8: switch (str[0]) {
      case 'c': low = 8; break;
      case 'r': low = 9; break;
      default: break;
    }
    break;
    case 10: low = 10;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, user_command_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_user_command_get_field(void *retval, const char *str, size_t len)
{
  int hash = user_command_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + user_command_table[hash].ptr_off);
}

KeySetLink get_autocmds_table[] = {
  {"event", offsetof(KeyDict_get_autocmds, event)},
  {"group", offsetof(KeyDict_get_autocmds, group)},
  {"buffer", offsetof(KeyDict_get_autocmds, buffer)},
  {"pattern", offsetof(KeyDict_get_autocmds, pattern)},
  {NULL, 0},
};

int get_autocmds_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 5: switch (str[0]) {
      case 'e': low = 0; break;
      case 'g': low = 1; break;
      default: break;
    }
    break;
    case 6: low = 2;   break;
    case 7: low = 3;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, get_autocmds_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_get_autocmds_get_field(void *retval, const char *str, size_t len)
{
  int hash = get_autocmds_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + get_autocmds_table[hash].ptr_off);
}

KeySetLink clear_autocmds_table[] = {
  {"event", offsetof(KeyDict_clear_autocmds, event)},
  {"group", offsetof(KeyDict_clear_autocmds, group)},
  {"buffer", offsetof(KeyDict_clear_autocmds, buffer)},
  {"pattern", offsetof(KeyDict_clear_autocmds, pattern)},
  {NULL, 0},
};

int clear_autocmds_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 5: switch (str[0]) {
      case 'e': low = 0; break;
      case 'g': low = 1; break;
      default: break;
    }
    break;
    case 6: low = 2;   break;
    case 7: low = 3;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, clear_autocmds_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_clear_autocmds_get_field(void *retval, const char *str, size_t len)
{
  int hash = clear_autocmds_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + clear_autocmds_table[hash].ptr_off);
}

KeySetLink exec_autocmds_table[] = {
  {"group", offsetof(KeyDict_exec_autocmds, group)},
  {"buffer", offsetof(KeyDict_exec_autocmds, buffer)},
  {"pattern", offsetof(KeyDict_exec_autocmds, pattern)},
  {"modeline", offsetof(KeyDict_exec_autocmds, modeline)},
  {NULL, 0},
};

int exec_autocmds_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 5: low = 0;   break;
    case 6: low = 1;   break;
    case 7: low = 2;   break;
    case 8: low = 3;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, exec_autocmds_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_exec_autocmds_get_field(void *retval, const char *str, size_t len)
{
  int hash = exec_autocmds_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + exec_autocmds_table[hash].ptr_off);
}

KeySetLink highlight_table[] = {
  {"bg", offsetof(KeyDict_highlight, bg)},
  {"fg", offsetof(KeyDict_highlight, fg)},
  {"sp", offsetof(KeyDict_highlight, sp)},
  {"bold", offsetof(KeyDict_highlight, bold)},
  {"link", offsetof(KeyDict_highlight, link)},
  {"temp", offsetof(KeyDict_highlight, temp)},
  {"blend", offsetof(KeyDict_highlight, blend)},
  {"cterm", offsetof(KeyDict_highlight, cterm)},
  {"global", offsetof(KeyDict_highlight, global)},
  {"italic", offsetof(KeyDict_highlight, italic)},
  {"special", offsetof(KeyDict_highlight, special)},
  {"ctermbg", offsetof(KeyDict_highlight, ctermbg)},
  {"ctermfg", offsetof(KeyDict_highlight, ctermfg)},
  {"default", offsetof(KeyDict_highlight, default_)},
  {"reverse", offsetof(KeyDict_highlight, reverse)},
  {"fallback", offsetof(KeyDict_highlight, fallback)},
  {"standout", offsetof(KeyDict_highlight, standout)},
  {"underdot", offsetof(KeyDict_highlight, underdot)},
  {"nocombine", offsetof(KeyDict_highlight, nocombine)},
  {"undercurl", offsetof(KeyDict_highlight, undercurl)},
  {"underdash", offsetof(KeyDict_highlight, underdash)},
  {"underline", offsetof(KeyDict_highlight, underline)},
  {"background", offsetof(KeyDict_highlight, background)},
  {"foreground", offsetof(KeyDict_highlight, foreground)},
  {"strikethrough", offsetof(KeyDict_highlight, strikethrough)},
  {"underlineline", offsetof(KeyDict_highlight, underlineline)},
  {NULL, 0},
};

int highlight_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 2: switch (str[0]) {
      case 'b': low = 0; break;
      case 'f': low = 1; break;
      case 's': low = 2; break;
      default: break;
    }
    break;
    case 4: switch (str[0]) {
      case 'b': low = 3; break;
      case 'l': low = 4; break;
      case 't': low = 5; break;
      default: break;
    }
    break;
    case 5: switch (str[0]) {
      case 'b': low = 6; break;
      case 'c': low = 7; break;
      default: break;
    }
    break;
    case 6: switch (str[0]) {
      case 'g': low = 8; break;
      case 'i': low = 9; break;
      default: break;
    }
    break;
    case 7: switch (str[5]) {
      case 'a': low = 10; break;
      case 'b': low = 11; break;
      case 'f': low = 12; break;
      case 'l': low = 13; break;
      case 's': low = 14; break;
      default: break;
    }
    break;
    case 8: switch (str[0]) {
      case 'f': low = 15; break;
      case 's': low = 16; break;
      case 'u': low = 17; break;
      default: break;
    }
    break;
    case 9: switch (str[5]) {
      case 'b': low = 18; break;
      case 'c': low = 19; break;
      case 'd': low = 20; break;
      case 'l': low = 21; break;
      default: break;
    }
    break;
    case 10: switch (str[0]) {
      case 'b': low = 22; break;
      case 'f': low = 23; break;
      default: break;
    }
    break;
    case 13: switch (str[0]) {
      case 's': low = 24; break;
      case 'u': low = 25; break;
      default: break;
    }
    break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, highlight_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_highlight_get_field(void *retval, const char *str, size_t len)
{
  int hash = highlight_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + highlight_table[hash].ptr_off);
}

KeySetLink keymap_table[] = {
  {"desc", offsetof(KeyDict_keymap, desc)},
  {"expr", offsetof(KeyDict_keymap, expr)},
  {"script", offsetof(KeyDict_keymap, script)},
  {"silent", offsetof(KeyDict_keymap, silent)},
  {"unique", offsetof(KeyDict_keymap, unique)},
  {"nowait", offsetof(KeyDict_keymap, nowait)},
  {"noremap", offsetof(KeyDict_keymap, noremap)},
  {"callback", offsetof(KeyDict_keymap, callback)},
  {NULL, 0},
};

int keymap_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 4: switch (str[0]) {
      case 'd': low = 0; break;
      case 'e': low = 1; break;
      default: break;
    }
    break;
    case 6: switch (str[1]) {
      case 'c': low = 2; break;
      case 'i': low = 3; break;
      case 'n': low = 4; break;
      case 'o': low = 5; break;
      default: break;
    }
    break;
    case 7: low = 6;   break;
    case 8: low = 7;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, keymap_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_keymap_get_field(void *retval, const char *str, size_t len)
{
  int hash = keymap_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + keymap_table[hash].ptr_off);
}

KeySetLink runtime_table[] = {
  {"is_lua", offsetof(KeyDict_runtime, is_lua)},
  {NULL, 0},
};

int runtime_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 6: low = 0;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, runtime_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_runtime_get_field(void *retval, const char *str, size_t len)
{
  int hash = runtime_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + runtime_table[hash].ptr_off);
}

KeySetLink float_config_table[] = {
  {"col", offsetof(KeyDict_float_config, col)},
  {"row", offsetof(KeyDict_float_config, row)},
  {"win", offsetof(KeyDict_float_config, win)},
  {"style", offsetof(KeyDict_float_config, style)},
  {"width", offsetof(KeyDict_float_config, width)},
  {"height", offsetof(KeyDict_float_config, height)},
  {"zindex", offsetof(KeyDict_float_config, zindex)},
  {"anchor", offsetof(KeyDict_float_config, anchor)},
  {"border", offsetof(KeyDict_float_config, border)},
  {"bufpos", offsetof(KeyDict_float_config, bufpos)},
  {"external", offsetof(KeyDict_float_config, external)},
  {"relative", offsetof(KeyDict_float_config, relative)},
  {"focusable", offsetof(KeyDict_float_config, focusable)},
  {"noautocmd", offsetof(KeyDict_float_config, noautocmd)},
  {NULL, 0},
};

int float_config_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 3: switch (str[0]) {
      case 'c': low = 0; break;
      case 'r': low = 1; break;
      case 'w': low = 2; break;
      default: break;
    }
    break;
    case 5: switch (str[0]) {
      case 's': low = 3; break;
      case 'w': low = 4; break;
      default: break;
    }
    break;
    case 6: switch (str[1]) {
      case 'e': low = 5; break;
      case 'i': low = 6; break;
      case 'n': low = 7; break;
      case 'o': low = 8; break;
      case 'u': low = 9; break;
      default: break;
    }
    break;
    case 8: switch (str[0]) {
      case 'e': low = 10; break;
      case 'r': low = 11; break;
      default: break;
    }
    break;
    case 9: switch (str[0]) {
      case 'f': low = 12; break;
      case 'n': low = 13; break;
      default: break;
    }
    break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, float_config_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_float_config_get_field(void *retval, const char *str, size_t len)
{
  int hash = float_config_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + float_config_table[hash].ptr_off);
}

KeySetLink eval_statusline_table[] = {
  {"winid", offsetof(KeyDict_eval_statusline, winid)},
  {"fillchar", offsetof(KeyDict_eval_statusline, fillchar)},
  {"maxwidth", offsetof(KeyDict_eval_statusline, maxwidth)},
  {"highlights", offsetof(KeyDict_eval_statusline, highlights)},
  {"use_tabline", offsetof(KeyDict_eval_statusline, use_tabline)},
  {NULL, 0},
};

int eval_statusline_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 5: low = 0;   break;
    case 8: switch (str[0]) {
      case 'f': low = 1; break;
      case 'm': low = 2; break;
      default: break;
    }
    break;
    case 10: low = 3;   break;
    case 11: low = 4;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, eval_statusline_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_eval_statusline_get_field(void *retval, const char *str, size_t len)
{
  int hash = eval_statusline_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + eval_statusline_table[hash].ptr_off);
}

KeySetLink highlight_cterm_table[] = {
  {"bold", offsetof(KeyDict_highlight_cterm, bold)},
  {"italic", offsetof(KeyDict_highlight_cterm, italic)},
  {"reverse", offsetof(KeyDict_highlight_cterm, reverse)},
  {"standout", offsetof(KeyDict_highlight_cterm, standout)},
  {"underdot", offsetof(KeyDict_highlight_cterm, underdot)},
  {"nocombine", offsetof(KeyDict_highlight_cterm, nocombine)},
  {"undercurl", offsetof(KeyDict_highlight_cterm, undercurl)},
  {"underdash", offsetof(KeyDict_highlight_cterm, underdash)},
  {"underline", offsetof(KeyDict_highlight_cterm, underline)},
  {"strikethrough", offsetof(KeyDict_highlight_cterm, strikethrough)},
  {"underlineline", offsetof(KeyDict_highlight_cterm, underlineline)},
  {NULL, 0},
};

int highlight_cterm_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 4: low = 0;   break;
    case 6: low = 1;   break;
    case 7: low = 2;   break;
    case 8: switch (str[0]) {
      case 's': low = 3; break;
      case 'u': low = 4; break;
      default: break;
    }
    break;
    case 9: switch (str[5]) {
      case 'b': low = 5; break;
      case 'c': low = 6; break;
      case 'd': low = 7; break;
      case 'l': low = 8; break;
      default: break;
    }
    break;
    case 13: switch (str[0]) {
      case 's': low = 9; break;
      case 'u': low = 10; break;
      default: break;
    }
    break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, highlight_cterm_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_highlight_cterm_get_field(void *retval, const char *str, size_t len)
{
  int hash = highlight_cterm_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + highlight_cterm_table[hash].ptr_off);
}

KeySetLink context_table[] = {
  {"types", offsetof(KeyDict_context, types)},
  {NULL, 0},
};

int context_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 5: low = 0;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, context_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_context_get_field(void *retval, const char *str, size_t len)
{
  int hash = context_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + context_table[hash].ptr_off);
}

KeySetLink set_extmark_table[] = {
  {"id", offsetof(KeyDict_set_extmark, id)},
  {"hl_eol", offsetof(KeyDict_set_extmark, hl_eol)},
  {"strict", offsetof(KeyDict_set_extmark, strict)},
  {"end_col", offsetof(KeyDict_set_extmark, end_col)},
  {"conceal", offsetof(KeyDict_set_extmark, conceal)},
  {"hl_mode", offsetof(KeyDict_set_extmark, hl_mode)},
  {"end_row", offsetof(KeyDict_set_extmark, end_row)},
  {"end_line", offsetof(KeyDict_set_extmark, end_line)},
  {"hl_group", offsetof(KeyDict_set_extmark, hl_group)},
  {"priority", offsetof(KeyDict_set_extmark, priority)},
  {"ephemeral", offsetof(KeyDict_set_extmark, ephemeral)},
  {"sign_text", offsetof(KeyDict_set_extmark, sign_text)},
  {"virt_text", offsetof(KeyDict_set_extmark, virt_text)},
  {"virt_lines", offsetof(KeyDict_set_extmark, virt_lines)},
  {"line_hl_group", offsetof(KeyDict_set_extmark, line_hl_group)},
  {"right_gravity", offsetof(KeyDict_set_extmark, right_gravity)},
  {"sign_hl_group", offsetof(KeyDict_set_extmark, sign_hl_group)},
  {"virt_text_pos", offsetof(KeyDict_set_extmark, virt_text_pos)},
  {"virt_text_hide", offsetof(KeyDict_set_extmark, virt_text_hide)},
  {"number_hl_group", offsetof(KeyDict_set_extmark, number_hl_group)},
  {"virt_lines_above", offsetof(KeyDict_set_extmark, virt_lines_above)},
  {"end_right_gravity", offsetof(KeyDict_set_extmark, end_right_gravity)},
  {"virt_text_win_col", offsetof(KeyDict_set_extmark, virt_text_win_col)},
  {"virt_lines_leftcol", offsetof(KeyDict_set_extmark, virt_lines_leftcol)},
  {"cursorline_hl_group", offsetof(KeyDict_set_extmark, cursorline_hl_group)},
  {NULL, 0},
};

int set_extmark_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 2: low = 0;   break;
    case 6: switch (str[0]) {
      case 'h': low = 1; break;
      case 's': low = 2; break;
      default: break;
    }
    break;
    case 7: switch (str[4]) {
      case 'c': low = 3; break;
      case 'e': low = 4; break;
      case 'o': low = 5; break;
      case 'r': low = 6; break;
      default: break;
    }
    break;
    case 8: switch (str[0]) {
      case 'e': low = 7; break;
      case 'h': low = 8; break;
      case 'p': low = 9; break;
      default: break;
    }
    break;
    case 9: switch (str[0]) {
      case 'e': low = 10; break;
      case 's': low = 11; break;
      case 'v': low = 12; break;
      default: break;
    }
    break;
    case 10: low = 13;   break;
    case 13: switch (str[0]) {
      case 'l': low = 14; break;
      case 'r': low = 15; break;
      case 's': low = 16; break;
      case 'v': low = 17; break;
      default: break;
    }
    break;
    case 14: low = 18;   break;
    case 15: low = 19;   break;
    case 16: low = 20;   break;
    case 17: switch (str[0]) {
      case 'e': low = 21; break;
      case 'v': low = 22; break;
      default: break;
    }
    break;
    case 18: low = 23;   break;
    case 19: low = 24;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, set_extmark_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_set_extmark_get_field(void *retval, const char *str, size_t len)
{
  int hash = set_extmark_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + set_extmark_table[hash].ptr_off);
}

KeySetLink option_table[] = {
  {"scope", offsetof(KeyDict_option, scope)},
  {NULL, 0},
};

int option_hash(const char *str, size_t len)
{
  int low = -1;
  switch (len) {
    case 5: low = 0;   break;
    default: break;
  }
  if (low < 0) {
    return -1;
  }
  if(memcmp(str, option_table[low].str, len)) {
    return -1;
  }
  return low;
}

Object *KeyDict_option_get_field(void *retval, const char *str, size_t len)
{
  int hash = option_hash(str, len);
  if (hash == -1) {
    return NULL;
  }

  return (Object *)((char *)retval + option_table[hash].ptr_off);
}

